# 細かいデータはQuoyleのヘルプを見てください。
from struct import *


class data:
    # マップを開いてヘッダ情報を読み込む。引数:filename（読み込むファイルの名前。）
    def __init__(self, filename):
        self.fn = open(filename, 'rb')
        # マップの幅を獲得。
        print("マップの幅を獲得します。")
        self.MAP_W = self.readShort(self.fn.read(2))

        # マップの高さを獲得。
        print("マップの高さを獲得します。")
        self.MAP_H = self.readShort(self.fn.read(2))

        # マップチップの幅を獲得。
        print("マップチップの幅を獲得します。")
        self.CHIP_W =self.readShort(self.fn.read(2))

        # マップチップの高さを獲得。
        print("マップチップの高さを獲得します。")
        self.CHIP_H = self.readShort(self.fn.read(2))

        print("レイヤーの数を獲得します。")
        self.LAYER_C = self.readByte(self.fn.read(1))
        print("チップカウントを獲得します。")
        self.CHIP_COUNT = self.readByte(self.fn.read(1))

        if self.CHIP_COUNT != 0:
            self.bysize = 2
        else:
            self.bysize = 1

    def readShort(self,val):
        return unpack('<h',val)[0]

    def readByte(self,val):
        return unpack('b',val)[0]

    def load(self,val,byte = 1):
        self.fn.seek(val)
        data = self.fn.read(byte)
        return data

    # マップ
    def get_pos(self, layer_index, x, y):
        print("マップチップの位置を読み取ります。")
        nindex = -1

        if layer_index > self.LAYER_C or x > self.MAP_W or y > self.MAP_H:
            return nindex

        layer = self.get_layer(layer_index)

        if self.bysize == 2:
            nindex = self.readShort(self.load(layer + y * self.MAP_W + x))
            return nindex
        else:
            nindex = self.readByte(self.load(layer + y * self.MAP_W + x))
            return nindex

    def get_layer(self, index):
        print("レイヤーを読み取ります。")
        # メモリと範囲をチェック
        if self.LAYER_C > index:
            return None

        return 16 + self.MAP_W * self.MAP_H * self.bysize * (index-1)

    # 以上のライブラリを利用してマップデータをリストに変換するサンプル。
    def data_load(self):
        map_data = [[]]
        # 開始時の位置を決める。
        for i in range(self.MAP_H):
            for j in range(self.MAP_W):
                if i < 0 and j == 0:
                    map_data.append([self.get_pos(1, j, i)])
                else:
                    map_data[i].append(self.get_pos(1, j, i))

        return map_data
